package plava;

public class PStore
{
  private static boolean storeOpen = false;
  private static final int MAXNUMROOTS = 5;

  private int maxNumRoots;
  private int numRoots;
  private PRoot roots[];

  private static boolean debug = true;

  /*
   * Opens the named persistent store.
   *
   */
   


    //Hmm this is what it looked like: (JL)

      public static PStore openStore (String storeName)
  throws StoreNotFoundException, StoreOpenException
  {
      /*PStore p;
    */    
    // check if a store is already open 
/*    if (storeOpen == true)
    {
      throw new StoreOpenException();
    }*/
    
    /* initialise store - exception will be thrown if it does not exist */
    /* it faults in the store's PStore root object and returns its LA */
/*    p = nativeOpenStore(storeName);*/

    /* remember that we've opened a store */
/*    storeOpen = true;*/

    /* return the store object */
/*    return p;*/

      if(debug)
	  System.out.println("PStore.openStore calling nativeGetRootObject");
      return nativeGetRootObject(); //This was left
	  }





  /*
   * Creates a new persistent store.
   *
   */

    /* Don't do this anymore   
  public static PStore newStore (String storeName)
  throws StoreExistsException, StoreOpenException
  {
      if(debug)
	  System.out.println("PStore.newStore");

    if (storeOpen == true)
    {
      throw new StoreOpenException();
    }


    PStore p = nativeNewStore(storeName);
    

    storeOpen = true;


    p.roots = new PRoot[MAXNUMROOTS];


    return p;
  }
    */

  public static PStore getStoreRoot ()
  {
      if(debug)
	  System.out.println("PStore.getStoreRoot");
    PStore p = nativeGetRootObject();
    if (p == null)
    {
    
      System.out.println("PStore.getStoreRoot: nativeGetRootObject returned null, creating new roots");
      p = new PStore();
      p.roots = new PRoot[MAXNUMROOTS];
      System.out.println("PStore.getStoreRoot: Calling nativeSetRootObject to set new roots");
      nativeSetRootObject(p);
    }
    return p;
  }

  /*
   * Closes an opened persistent store.
   *
   */

  public void closeStore ()
  {
      if(debug)
	  System.out.println("PStore.closeStore");
    if (storeOpen == true)
    {
      storeOpen = false;
      //nativeCloseStore();
    }
  }

  /*
   * Adds a persistent root to the store.
   *
   */
   
  public void addRoot(String n, Object o)
  {
      if(debug)
	  System.out.println("PStore.addRoot");
    numRoots += 1;
    if (numRoots > maxNumRoots)
    {
      PRoot newRoots[] = new PRoot[maxNumRoots * 2];
      for (int i = 0; i < maxNumRoots; i++)
      {
        newRoots[i] = roots[i];
      }
      maxNumRoots *= 2;
      roots = newRoots;
    }
    roots[numRoots - 1] = new PRoot(n, o);
  }

  /*
   * Returns a named persistent root.
   *
   */

  public Object getRoot(String name)
  {
    int i;
          if(debug)
	  System.out.println("PStore.getRoot (" + name + ")");
    for (i = 0; i < numRoots; i++)
    {
      if (roots[i].name.compareTo(name) == 0)
      {
        return roots[i].obj;
      }
    }
    return null;
  }

    /* Set root -- added by Jewel 19/9/99 */

  public void setRoot(String name, Object obj)
  {
    int i;
          if(debug)
	   System.out.println("PStore.setRoot (" + name + ")");
    for (i = 0; i < numRoots; i++)
    {
      if (roots[i].name.compareTo(name) == 0)
      {
        roots[i].obj = obj;
      }
    }
    return;
  }

  /*
   * Default constructor - just sets maxNumRoots and numRoots
   *
   */
   
  private PStore ()
  {
    maxNumRoots = MAXNUMROOTS;
    numRoots = 0;
  }

  /*
   * Actually opens the store file and returns the store's root object.
   *
   */
   
    //  private static native PStore nativeOpenStore(String name) throws StoreNotFoundException;
  
  /*
   * Creates a new store file and returns the store's root object.
   *
   */
   
    //  private static native PStore nativeNewStore(String name) throws StoreExistsException;

  /*
   * Closes the opened store.
   *
   */
   
    //  private native void nativeCloseStore();

  /*
   * Updates all resident objects in the store.
   *
   */

  public native void stabiliseAll();
  private static native PStore nativeGetRootObject();
  private static native void nativeSetRootObject(PStore o);

}

class PRoot
{
  String name;
  Object obj;

  PRoot(String n, Object o)
  {
    name = n;
    obj = o;
  }
}










