//kissme build flags

//This flag is always set. It's just a way to make sure that all headers are including this one
#define DADDY_IS_WATCHING

#define KISSME_LINUX_USER

//Flags whether the VM supports persistence of objects. has to be on, otherwise VM has problems.
#define PERSIST

//Use native threads as opposed to 'emulated' green threads. Always on.
#define NATIVE_THREADS

//Allocate the condition variable inside the object header, saves us doing a malloc/free for each new object
#ifdef KISSME_LINUX_USER
#define IN_PLACE_CONDITION
#endif

//#define GARBAGE_VERBOSE
//Use dynamic linking for libraries
#define DLOPEN 
//Garbage and memory management flags, GARBAGE must always be on. The rest you probably shouldn't change.
#define NEWRPOT
#define RPOTREFS
#define GARBAGE
#define HANDLEBLOCKS

//2nd generation GC code, uses GC points
#define GARBAGE2
#define ALLOCATOR

//use IBM flat and inflated locks -- this is still experimental, but enabled for this release
#define IBM_LOCKS
#define SABLE_LOCKS //variation on the above with contention bit in thread structure

//Uses a new form of method stacks. I haven't tested the alternative in a long time.
#define THREAD_EXPERIMENT

#define PREALLOCATE_OOM

//Enable the run-time optimiser. (Still in alpha development)
//#define ENABLE_SVETLANA
//Analyse the operations that are rejected by the optimiser and print them out
//#define ANALYSE_OPS
 
//#define STACKMAP
//#define VERIFIER

//Use QUICK instructions, leave this on for the Optimiser
//#define RESURRECT_QUICK

//#define USEOSKIT
//#define OSKIT

//Use the Classpath file IO as opposed to our own. Classpath is much more robust.
#define CLASSPATH_FILE_IO
#define CLASSPATH_BIGINTEGER
#define NETWORKING
#define CLASSPATH_NETWORKING

//#define GTKPEER

//when printing out stack traces:
//the IBM JDK behaviour is to print out the frames for the construction of the exception object. I think that's just silly
//the SUN JDK seems to hide the exception construction

//turn this off to see the construction of the exception object in the stack trace
//#define HIDE_EXCEPTION_CONSTRUCTION

//#define DEBUG_FRAMES
//#define DEBUG
//#define DEBUG_TRACE
//Show each function call made by the interpreter
//#define SHOW_CALLS
//#define SHOWLOADING
//show debug info related to creating threads and accessing thread structures
//#define SHOWTHREADS

//#define DEBUG_CPLIST

//#define HASH_INTEGRITY_CHECK //This is a kind of brute-force check which tries to trap errant pointer errors ASAP

#define LOG_NATIVE_CALLS //Log each native call for debugging (goes to a file in the ./log directory)

//Allow jos stuff to access raw hardware
//#define RAWVIDEO

//use the ncurses library to provide text access
#define CURSES_CONSOLE

//Show the locks / monitors being obtained and released
//#define DEBUG_LOCKS

#define USE_JAVA_CLASSLOADER
#define HAVE_JVMDI

//#define COLTRANE
#include "vm/sys_linux_host/wrappers.h"

#ifdef KISSME_LINUX_USER
 #define eprintf(format, args...) fprintf(stderr, format, ## args)
#endif

#define KISSME_VERSION "0.20"
#define KISSME_BUILD_DATE __DATE__
















