package kissme_test;

import java.io.InputStream;
import java.util.Hashtable;

import java.io.IOException;
import java.io.FileNotFoundException;
import java.io.File;
import java.io.BufferedReader;
import java.io.FileReader;

import java.io.FileInputStream;

import java.util.ResourceBundle;
import java.util.Hashtable;
import java.util.Enumeration;

public class ArrayTest
{

  public String[][] getMimeStrings() {
    return mime_strings;
  }
protected static final String[][] mime_strings = {
  { "application/mac-binhex40", "hqx" },
  { "application/mac-compactpro", "cpt" },
  { "application/msword", "doc" },
  { "application/octet-stream", "bin" },
  { "application/octet-stream", "dms" },
  { "application/octet-stream", "lha" },
  { "application/octet-stream", "lzh" },
  { "application/octet-stream", "exe" },
  { "application/octet-stream", "class" },
  { "application/oda", "oda" },
  { "application/pdf", "pdf" },
  { "application/postscript", "ai" },
  { "application/postscript", "eps" },
  { "application/postscript", "ps" },
  { "application/powerpoint", "ppt" },
  { "application/rtf", "rtf" },
  { "application/x-bcpio", "bcpio" },
  { "application/x-cdlink", "vcd" },
  { "application/x-compress", "Z" },
  { "application/x-cpio", "cpio" },
  { "application/x-csh", "csh" },
  { "application/x-director", "dcr" },
  { "application/x-director", "dir" },
  { "application/x-director", "dxr" },
  { "application/x-dvi", "dvi" },
  { "application/x-gtar", "gtar" },
  { "application/x-gzip", "gz" },
  { "application/x-hdf", "hdf" },
  { "application/x-httpd-cgi", "cgi" },
  { "application/x-koan", "skp" },
  { "application/x-koan", "skd" },
  { "application/x-koan", "skt" },
  { "application/x-koan", "skm" },
  { "application/x-latex", "latex" },
  { "application/x-mif", "mif" },
  { "application/x-netcdf", "nc" },
  { "application/x-netcdf", "cdf" },
  { "application/x-sh", "sh" },
  { "application/x-shar", "shar" },
  { "application/x-stuffit", "sit" },
  { "application/x-sv4cpio", "sv4cpio" },
  { "application/x-sv4crc", "sv4crc" },
  { "application/x-tar", "tar" },
  { "application/x-tcl", "tcl" },
  { "application/x-tex", "tex" },
  { "application/x-texinfo", "texinfo" },
  { "application/x-texinfo", "texi" },
  { "application/x-troff", "t" },
  { "application/x-troff", "tr" },
  { "application/x-troff", "roff" },
  { "application/x-troff-man", "man" },
  { "application/x-troff-me", "me" },
  { "application/x-troff-ms", "ms" },
  { "application/x-ustar", "ustar" },
  { "application/x-wais-source", "src" },
  { "application/zip", "zip" },
  { "audio/basic", "au" },
  { "audio/basic", "snd" },
  { "audio/mpeg", "mpga" },
  { "audio/mpeg", "mp2" },
  { "audio/mpeg", "mp3" },
  { "audio/x-aiff", "aif" },
  { "audio/x-aiff", "aiff" },
  { "audio/x-aiff", "aifc" },
  { "audio/x-pn-realaudio", "ram" },
  { "audio/x-pn-realaudio-plugin", "rpm" },
  { "audio/x-realaudio", "ra" },
  { "audio/x-wav", "wav" },
  { "chemical/x-pdb", "pdb" },
  { "chemical/x-pdb", "xyz" },
  { "image/gif", "gif" },
  { "image/ief", "ief" },
  { "image/jpeg", "jpeg" },
  { "image/jpeg", "jpg" },
  { "image/jpeg", "jpe" },
  { "image/png", "png" },
  { "image/tiff", "tiff" },
  { "image/tiff", "tif" },
  { "image/x-cmu-raster", "ras" },
  { "image/x-portable-anymap", "pnm" },
  { "image/x-portable-bitmap", "pbm" },
  { "image/x-portable-graymap", "pgm" },
  { "image/x-portable-pixmap", "ppm" },
  { "image/x-rgb", "rgb" },
  { "image/x-xbitmap", "xbm" },
  { "image/x-xpixmap", "xpm" },
  { "image/x-xwindowdump", "xwd" },
  { "text/html", "html" },
  { "text/html", "htm" },
  { "text/plain", "txt" },
  { "text/richtext", "rtx" },
  { "text/tab-separated-values", "tsv" },
  { "text/x-setext", "etx" },
  { "text/x-sgml", "sgml" },
  { "text/x-sgml", "sgm" },
  { "video/mpeg", "mpeg" },
  { "video/mpeg", "mpg" },
  { "video/mpeg", "mpe" },
  { "video/quicktime", "qt" },
  { "video/quicktime", "mov" },
  { "video/x-msvideo", "avi" },
  { "video/x-sgi-movie", "movie" },
  { "x-conference/x-cooltalk", "ice" },
  { "x-world/x-vrml", "wrl" },
  { "x-world/x-vrml", "vrml" }
  };



private static Hashtable mime_types = new Hashtable(150);

static
{
  for (int i = 0; i < mime_strings.length; i++)
    mime_types.put(mime_strings[i][1], mime_strings[i][0]);
}


    public ArrayTest()
    {
	for(int i = 0; i < mime_strings.length;i++)
	    System.out.println( mime_strings[i][0] + " " + mime_strings[i][1]);

	//Now check 3 dimensional array
	int [][][] dim3 = new int[1][2][3];
	
	//Now 3! = 6
	int progress = 0;

	for(int i = 0; i < 1; i++)
	    for(int j = 0; j < 2; j++)
		for(int k = 0; k < 3; k++)
		    dim3[i][j][k] = progress++;

	System.out.println("Dumping 3 dim");
	for(int i = 0; i < 1; i++)
	    for(int j = 0; j < 2; j++)
		for(int k = 0; k < 3; k++)
		    System.out.print(" " + dim3[i][j][k]);

	//And with Strings

	String [][][] sdim3 = new String[1][2][3];
	
	//Now 3! = 6
	progress = 0;

	for(int i = 0; i < 1; i++)
	    for(int j = 0; j < 2; j++)
		for(int k = 0; k < 3; k++)
		    sdim3[i][j][k] = new Integer(progress++).toString();

	System.out.println("Dumping 3 sdim");
	for(int i = 0; i < 1; i++)
	    for(int j = 0; j < 2; j++)
		for(int k = 0; k < 3; k++)
		    System.out.print(" " + dim3[i][j][k]);

	System.out.println("Dumped 3 sdim");
	//And something more sophisticated
	int [][][][][] bigarray = new int[6][5][4][3][2];

	for(int i = 0; i < 6; i++)
	    for(int j = 0; j < 5; j++)
		for(int k = 0; k < 4; k++)
		    for(int l = 0; l < 3; l++)
			for(int m = 0; m < 2; m++)
			    bigarray[i][j][k][l][m] = progress++;

	System.out.println("Dumping bigarray");
	for(int i = 0; i < 6; i++)
	    for(int j = 0; j < 5; j++)
		for(int k = 0; k < 4; k++)
		    for(int l = 0; l < 3; l++)
			for(int m = 0; m < 2; m++)
			    System.out.print(" " + bigarray[i][j][k][l][m]);

	System.out.println("Dumped bigarray");
	//Now check illegal offset
	byte[] illegalArray = new byte[200];
	try {

	    illegalArray[-32] = (byte) 22;
	    System.err.println("Didn't get exception !!!!!!!!!!!!!!!");
	} catch(ArrayIndexOutOfBoundsException aie)
	    {
		System.err.println("Got Exception -- correct");
	    }

    }
    public static void main(String[] argv)
    {
	new ArrayTest();
    }

}

