package kissme_test;
import java.lang.reflect.Constructor;
import java.lang.reflect.Method;
import java.lang.reflect.Field;

import java.io.Serializable;
import java.util.Hashtable;



public class ReflectionTest
{
    int fieldA;
    long fieldB;
    Class fieldC;

    public ReflectionTest(String bobo)
    {
	System.out.println("Constructed with " + bobo + " !!!");
    }

    public ReflectionTest(String bobo, Float f, byte m, int j, short s, char ch, byte b, Double d, double c) 
    {

    }

    public ReflectionTest() throws NoSuchMethodException, ClassNotFoundException
    {
      fieldA = 77;
	Class c = this.getClass();

	System.out.println("First getting the java/lang/Class for ReflectionTest: " + c + "\n");
	System.out.println("Checking for Class.forName of a non-existent class");
try    {
	Class b = Class.forName("youll.never.find.this");
} catch(ClassNotFoundException cnf)
    {
	System.out.println("Got the correct exception " + cnf);
    }

try {
	 System.out.println("--- Getting void method ---");
	 Class[] vtypes = new Class[2];
	 vtypes[0] = Integer.class;
	 vtypes[1] = Double.class;
	 Method vmethod = c.getMethod("voidMethod", vtypes);
	 Object[] iargs = new Object[2];
	 iargs[0] = new Integer(2);
	 iargs[1] = new Double(3);
	 Object ret = vmethod.invoke(this, iargs);

	 System.out.println("--- ret from void method is " + ret + " ---");
} catch(Exception e)
  {
    e.printStackTrace();
  }
	 System.out.println("--- About to get ctors ---");
	 
         Constructor[] cons = c.getConstructors();

	System.out.println("There are  " + cons.length + " constructors\n");

	Constructor one = cons[0];
	Constructor two = cons[1];
	Constructor three = cons[2];

	System.out.println("--- About to print ctor 1,2 & 3 ---");
	
	System.out.println("Cons 1 is null " + (one == null) + "\n");
	System.out.println("Cons 2 is null " + (two == null) + "\n");
	System.out.println("Cons 3 is null " + (two == null) + "\n");

	System.out.println("--- About to get param types for cons 1 ---");

	Class[] params = one.getParameterTypes();
	for(int p = 0; p < params.length;p++)
	    {
		System.out.println("Constructor one has parameter " + params[p]);
	    }

	System.out.println("--- About to get param types for cons 2 ---");

	 params = two.getParameterTypes();
	for(int p = 0; p < params.length;p++)
	    {
		System.out.println("Constructor two has parameter " + params[p]);
	    }

	System.out.println("--- About to get param types for cons 3 ---");

	 params = three.getParameterTypes();
	for(int p = 0; p < params.length;p++)
	    {
		System.out.println("Constructor three has parameter " + params[p]);
	    }


	System.out.println("--- finished with parameter types, now doing a newInstance() ---");

				//NOw do a newInstance

				Object[] conargs = new Object[1];
				conargs[0] = "greekfood";
				try {
				    System.out.println("--- About to call class ctor ---");
				    if(cons[2].getParameterTypes().length == 1)
				     cons[2].newInstance(conargs);
				    else if(cons[1].getParameterTypes().length == 1)
				     cons[1].newInstance(conargs);
				    else
				     cons[0].newInstance(conargs);
				    System.out.println("--- called class ctor ---");
				} catch(Exception  ite)
				    {
					ite.printStackTrace();
				    }
				
	System.out.println("--- no exception should have occurred ---");

	System.out.println("--- Now we see if the getMethod will match \"funkyMethod\" and an array of Classes ---");

				try {
				    Class[] args = new Class[2];
				    args[0] = Class.forName("java.io.Serializable");
				    args[1] = Class.forName("java.util.Hashtable");

				    Method m = c.getMethod("funkyMethod", args);

				    System.out.println("got method " + m);

				    System.out.println("--- Printing parameters for funkyMethod ---");

				    Class[] parameters = m.getParameterTypes();
				    System.out.println("There are " + parameters.length + " parameters");
				    for(int k = 0; k < parameters.length;k++)
					System.out.println("parameter[" + k + "]: " + parameters[k]);


				    System.out.println("--- Printing out fields for this object ---");

				    Field[] fields = c.getFields();

				    System.out.println("We got " + fields.length + " fields");


				    for(int i = 0; i < fields.length;i++)
					{
					    System.out.println("Field " + fields[i]);
					}

				    System.out.println("--- Printing out methods for this object ---");

				    Method[] methods = c.getMethods();

				    System.out.println("We got " + methods.length + " methods");


				    for(int i = 0; i < methods.length;i++)
					{
					    System.out.println("Method["+i+"]: " + methods[i]);
					}
				    
				    System.out.println("--- Printing out method[2] (main) ---");

				    Class[] mparams = methods[2].getParameterTypes();

				    for(int i = 0; i < mparams.length;i++)
					{
					    System.out.println("Param["+i+"]: " + mparams[i]);
					}

		} catch(NoSuchMethodException nsme)
		    {
			System.out.println("--**-- Couldn't find the method funkyMethod --**--");
		    }
		 catch(ClassNotFoundException cnf)
		     {
			 System.out.println("Class not found");
		     }

		 System.err.println("***Doing rhino tests***");
		 /*		 
		 Class rclass = Class.forName("org.mozilla.javascript.NativeFunction");
		 Class[] types = { org.mozilla.javascript.Context.class, Object[].class, org.mozilla.javascript.Function.class, java.lang.Boolean.TYPE};
		 Method rmethod = rclass.getMethod("js_Function", types);

		 System.err.println(rmethod);

		 Class[] rtypes = rmethod.getParameterTypes();

		 for(int i = 0; i < rtypes.length;i++)
		   {
		     if( types[i] != rtypes[i])
		       {
			 System.err.println("Types dont match" + i);
		       }
		   }

		 System.err.println("1 " + rtypes[0] + " " + (rtypes[0] == Context.class));
		 System.err.println("1 " + rtypes[0].hashCode() + " " + (Context.class.hashCode()));
		 System.err.println("2 " + rtypes[1].getComponentType() + " " + (ScriptRuntime.ObjectClass) + " " + (rtypes[1].getComponentType() == ScriptRuntime.ObjectClass));
		 System.err.println("2 " + rtypes[1].getComponentType().hashCode() + " " + (ScriptRuntime.ObjectClass.hashCode()));
		 System.err.println("3 " + rtypes[2] + " " + (rtypes[2] == ScriptRuntime.FunctionClass));
		 System.err.println("4 " + rtypes[3] + " " + (Boolean.TYPE) + " " + (rtypes[3] == Boolean.TYPE));
		 System.err.println("4 " + rtypes[3].hashCode() + " " + (Boolean.TYPE.hashCode()));
		 
		 System.err.println("***Did rhino tests***");*/
    }

    public int anotherArbMethod(int a, byte b, short c)
    {
	return 27;
    }
    public Constructor funkyMethod(Serializable a, Hashtable  b)
    {
	return null;
    }

static int save;
  public void voidMethod(Integer a, Double b) 
  {
    save = (int) (a.intValue() + b.doubleValue() + 3);
  }

    public static void main(String[] argv) throws NoSuchMethodException, ClassNotFoundException
    {
	System.out.println("--- starting Reflection Test ---");
	new ReflectionTest();
	Class c = argv.getClass();
	System.out.println("Array class: " + c + "\n");
	Constructor[] cons = c.getConstructors();
	System.out.println("*" + cons + "*");
	System.out.println("--- finished Reflection Test ---");
	
	try {
	runTest();
	} catch(Exception e)
	  {
	    e.printStackTrace();
	  }
    }

  public static void runTest() throws Exception
  {
	try {
	System.out.println("Integer class " + Class.forName("I"));
	} catch(Exception e)
	  {
	    System.out.println(e);
	  }
	try {
	System.out.println("int class " + Class.forName("int"));
	} catch(Exception e)
	  {
	    System.out.println(e);
	  }
	try {
	System.out.println("double class " + Class.forName("double"));
	} catch(Exception e)
	  {
	    System.out.println(e);
	  }

	try {
	System.out.println("Void class " + Class.forName("void"));
	} catch(Exception e)
	  {
	    System.out.println(e);
	  }
	try {
	System.out.println("i class " + Class.forName("i"));
	} catch(Exception e)
	  {
	    System.out.println(e);
	  }
	try {
	System.out.println("; class " + Class.forName(";"));
	} catch(Exception e)
	  {
	    System.out.println(e);
	  }
	try {
	System.out.println("L; class " + Class.forName("L;"));
	} catch(Exception e)
	  {
	    System.out.println(e);
	  }
	try {
	System.out.println("Lsomething; class " + Class.forName("Lsomething;"));
	} catch(Exception e)
	  {
	    System.out.println(e);
	  }
	try {
	System.out.println("[something class " + Class.forName("[java.lang.Object"));
	} catch(Exception e)
	  {
	    System.out.println(e);
	  }
	try {
	System.out.println("[ class " + Class.forName("["));
	} catch(Exception e)
	  {
	    System.out.println(e);
	  }
	try {
	System.out.println("[[ class " + Class.forName("[["));
	} catch(Exception e)
	  {
	    System.out.println(e);
	  }
	System.out.println("Integer class " + java.lang.Integer.TYPE);
	System.out.println("Integer class " + java.lang.Integer.TYPE + " component " + java.lang.Integer.TYPE.getComponentType());
	System.out.println("Array of Integer class " + Class.forName("[I") + " component " + Class.forName("[I").getComponentType());
	System.out.println("Array of Array Integer class " + Class.forName("[[I") + " component " + Class.forName("[[I").getComponentType());

	System.out.println("Object class " + Class.forName("java.lang.Object") + " component " + Class.forName("java.lang.Object").getComponentType());
	System.out.println("Array of Object class " + Class.forName("[Ljava.lang.Object;") + " component " + Class.forName("[Ljava.lang.Object;").getComponentType());
	System.out.println("Array of Array of Object class " + Class.forName("[[Ljava.lang.Object;") + " component " + Class.forName("[[Ljava.lang.Object;").getComponentType());

    }

}







